#  AreaEd - an editor for rom-style areas, especially for
#  Dawn of the Ages  http://dawn.netcologne.de
#
#  Copyright (C) 2001 Peter Herth <p.herth@uni-koeln.de>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.



from gtk import *
from gnome.ui import *
from GtkExtra import *
from GDK import *
from GTK import *

from Tools import *
#from Area import *
from Area import *
import Area

def dnd_drag_data_received(w, context, x, y, data, info, time):
    if data and data.format == 8:
        m = None
        if len(data.data)>0 :
            sio = StringIO(data.data)
            m = cPickle.load(sio)
        msg = "Drop data of type %s was:\n\n%s" % \
              (data.target, m.short)
        message_box("Drop", msg,("Continue",))

class ExitEdit(GtkTable):
    connects=[]
    connect = None
    bexits = []
    cbactive = []
    ds_num=0
    ed = None
    Directions=['North','East','South','West','Up','Down']

    def __init__(self,list,ed):
        self.connects = list
        self.ed=ed
        GtkTable.__init__(self,9,3)
        #tab1=GtkTable(1,1)
        #l_act = GtkLabel("Active: ")
        #l_act.set_justify(JUSTIFY_CENTER)
        #tab1.attach(l_act,0,1,0,1,FILL|EXPAND,0,XPAD,YPAD)
        #self.attach(tab1,0,1,0,1,FILL|EXPAND,FILL|EXPAND,XPAD,YPAD)

        
        frame1=GtkFrame("Directions")
        bbox1=GtkVButtonBox()
        bbox2=GtkVButtonBox()
        for i in range(6):
            self.cbactive[i:i]=[GtkCheckButton()]
            self.bexits[i:i]=[GtkButton(self.Directions[i])]
            self.cbactive[i].connect("toggled",self.togglecbActive,i)
            self.bexits[i].connect("clicked",self.ChangeDir,i)
            bbox1.pack_start(self.cbactive[i])
            bbox2.pack_start(self.bexits[i])
        ft1=GtkTable(1,2)
        ft1.attach(bbox1,0,1,0,1,EXPAND,0,XPAD,YPAD)
        ft1.attach(bbox2,1,2,0,1,EXPAND,0,XPAD,YPAD)
        #self.attach(bbox1,0,1,1,7)
        #self.attach(bbox2,1,2,1,7)
        frame1.add(ft1)
        self.attach(frame1,0,2,0,7,SHRINK,SHRINK,XPAD,YPAD)
        frame2=GtkFrame("Details")
        box=GtkTable(2,6)
        self.roomToVnum=mk_le("to Room",box,0,0)
        self.keyphrase=mk_le("Keyphrase",box,2,0)
        self.keyVnum=mk_le("Key",box,4,0)
        mklabel("Doorstate:",box,2,1)
        ds=GtkCombo()
        ds.set_popdown_strings(["open","closed","pickproof","nopass","pickproof,nopass"])
        ds.set_value_in_list(TRUE,TRUE)
        ds.list.connect("select-child",self.set_doorstate)
        ds.show()
        box.attach(ds,3,4,1,2,SHRINK|FILL)
        mklabel("reset as locked",box,0,1)
        locked=GtkCheckButton()
        box.attach(locked,1,2,1,2)
        self.locked=locked
        self.doorstate=ds
        frame2.add(box)
        self.fr_det=frame2
        self.attach(frame2,2,3,0,2,SHRINK|FILL,SHRINK|FILL,XPAD,YPAD)

        frame3=GtkFrame("Description")
        desc=GtkText()
        desc.set_editable(TRUE)
        desc.set_usize(1,64)
        desc.show()
        frame3.add(desc)
        self.fr_desc=frame3
        self.attach(frame3,2,3,3,7)
        self.desc=desc
        appl=GtkButton("Apply now")
        appl.connect("clicked",self.Apply)
        self.attach(appl,2,3,8,9,FILL|EXPAND|SHRINK,0,0,YPAD)

    def set_doorstate(self,*args):
        self.ds_num=self.doorstate.list.child_position(args[1])
        if self.ds_num==0:
            self.locked.set_active(FALSE)
        self.locked.set_sensitive(self.ds_num!=0)
        

    def Apply(self,*args):
        self.save()
        self.connects=self.getExits()
        
    def togglecbActive(self,*args):
        self.updateButtons(args[1])

    def updateButtons(self,i):
        self.bexits[i].set_sensitive(self.cbactive[i].active)
   
    def ChangeDir(self,*args):
        self.save()
        if self.connects[args[1]]==None:
            self.connects[args[1]]=Exit()
            self.connects[args[1]].dir=args[1]
        self.set(self.connects[args[1]])

    def set(self,con):
        self.save()
        if con:
            self.connect=con
            self.roomToVnum.set_text(con.roomToVnum)
            self.keyphrase.set_text(con.keyphrase)
            self.keyVnum.set_text(con.keyVnum)
            self.doorstate.list.select_item(int(con.doorstate))
            self.ds_num=int(con.doorstate)
            self.desc.delete_text(0,-1)
            self.desc.insert_defaults(con.desc)
            self.fr_desc.set_label("Description of exit to the "+self.Directions[con.dir])
            self.fr_det.set_label("Details of exit to the "+self.Directions[con.dir])
            if self.ed.roomform.room!=None:
                for r in self.ed.roomform.room.resets:
                    if (r.v[0]=="D") and (r.v[3]==str(con.dir)):
                       self.locked.set_active(r.v[4]=="2")
                
        else:
            self.connect=None
            self.roomToVnum.set_text("")
            self.keyphrase.set_text("")
            self.keyVnum.set_text("")
            self.doorstate.list.select_item(0)
            self.ds_num=0
            self.desc.delete_text(0,-1)
            self.fr_desc.set_label("Description")
            self.fr_det.set_label("Details")
            self.locked.set_active(FALSE)
            
    def save(self):
        if self.connect != None:
            self.connect.roomToVnum=self.roomToVnum.get_text()
            self.connect.keyphrase=self.keyphrase.get_text()
            self.connect.keyVnum=self.keyVnum.get_text()
            self.connect.doorstate=str(self.ds_num)
            self.connect.desc=self.desc.get_chars(0,self.desc.get_length())
            if self.ed.roomform.room!=None:
                self.ed.roomform.room.redrawExits()
                found=FALSE
                for r in self.ed.roomform.room.resets:
                    if (r.v[0]=="D") and (r.v[3]==str(self.connect.dir)):
                        found=TRUE
                        if self.locked.active:
                            r.v[4]="2"
                            #print(r.v)
                        else:
                            if self.ds_num>0:
                                r.v[4]="1"
                                #print(r.v)
                            else:
                                self.ed.roomform.room.resets.remove(r)
                                self.ed.area.resets.remove(r)

                if (not found) and (self.ds_num>0):
                    r = Reset()
                    print("New Reset!")
                    if self.locked.active:
                        l="2"
                    else:
                        l="1"
                    r.v = ["D","0",self.ed.roomform.room.vnum,str(self.connect.dir),l]
                    #print(r.v)
                    self.ed.roomform.room.resets.append(r)
                    self.ed.area.resets.append(r)
                self.ed.roomform.update_resets()
    
    def setExits(self,list):
        self.connects=list
        self.set(None)
        if len(list)==0:
            return
        elif len(list)==6:
            for i in range(6):
                if list[i]!=None:
                    self.set(list[i])
                    self.cbactive[i].set_active(TRUE)
                else:
                    self.cbactive[i].set_active(FALSE)
                self.updateButtons(i)
        else:
            error("Wrong number of connects!!")

    def getExits(self):
        self.save()
        for i in range(6):
            if not self.cbactive[i].active:
                self.connects[i]=None
        return self.connects

class KoordEd(GtkTable):
    def __init__(self,ed):
        self.connects = list
        self.ed=ed
        GtkTable.__init__(self,6,3)
        self.x = mk_le("x:",self, 0,1)
        self.y = mk_le("y:",self, 2,1)
        self.z = mk_le("z:",self, 4,1)
        self.w = mk_le("width:",self, 0,2)
        self.l = mk_le("length:",self, 2,2)
        self.h = mk_le("height::",self, 4,2)
        
    def setKoords(self, room):
        self.x.set_text("%d" % room.x)
        self.y.set_text("%d" % room.y)
        self.z.set_text("%d" % room.z)
        self.w.set_text("%d" % room.width)
        self.l.set_text("%d" % room.length)
        self.h.set_text("%d" % room.height)
        #room.calcCoords()
        
    def fillKoords(self, room):
        room.x = int(self.x.get_text())
        room.y = int(self.y.get_text())
        room.z = int(self.z.get_text())
        room.width = int(self.w.get_text())
        room.length = int(self.l.get_text())
        room.height = int(self.h.get_text())
        #room.calcCoords()
    
class RoomForm(EditForm):

##    def next(self, *arg):
##        if self.actroom < (len(self.ed.area.rooms)-1):
##            self.actroom = self.actroom + 1
##            self.setRoom(self.ed.area.rooms[self.actroom])
                
##    def prev(self, *arg):
##        if self.actroom>0:
##            self.actroom = self.actroom -1
##            self.setRoom(self.ed.area.rooms[self.actroom])





    def __init__(self,editor):
        EditForm.__init__(self, editor, editor.area.rooms)
        self.ed = editor
        self.roomflags=[]
        self.room=None
        self.tooltips = GtkTooltips()

        self.vnum_entry = mk_le("Vnum:",self,0,1)
        mklabel("               ",self, 2,1)
        mklabel("               ",self, 3,1)
        mklabel("               ",self, 4,1)

        #prev = mk_gbu(STOCK_BUTTON_PREV,table,5,0,6)
        #next = mk_gbu(STOCK_BUTTON_NEXT,table,7,0,8)
        #prev.connect("clicked",self.prev)
        #next.connect("clicked",self.next)
        
        self.name = mk_le("Name:",self,0,2,8)

        label = mklabel("Desc:",self, 0,3)
        
        desc = GtkText()
        desc.set_editable(TRUE)
        desc.set_usize(1,ROOMDESCHEIGHT)
        desc.show()
        self.attach(desc,1,10,3,5,FILL|EXPAND|SHRINK,EXPAND|FILL, XPAD, YPAD)
        self.desc = desc

        reset_table = GtkTable(2,2)
        rf = GtkFrame("Room")
        resets = GtkList()

        swin = GtkScrolledWindow()
        swin.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC)
        swin.add_with_viewport(resets)
        resets.show()
        #resets.realize()
        resets.drag_source_set(GDK.BUTTON1_MASK, dnd_targets, GDK.ACTION_COPY)

##        list_items = ("hello", "world", "blah", "foo", "bar", "argh")
##        for i in list_items:
##            list_item = GtkListItem(i)
##            resets.add(list_item)
##            list_item.show()
        ###resets.drag_dest_set(DEST_DEFAULT_ALL, [("move", 0, -1)],ACTION_COPY)
        
        #resets.connect("drag_data_received", self.drag_rec)
        resets.connect('drag_data_received', self.data_received)
        resets.drag_dest_set(DEST_DEFAULT_ALL, targets_mob,GDK.ACTION_COPY)
        resets.set_selection_mode(SELECTION_BROWSE)
        resets.connect("select_child", self.reset_click)


        self.resets = resets
        rf.add(swin)
        reset_table.attach(rf,0,1,0,2)
        ef = GtkFrame("Equip")
        equips = GtkList()

        equips.connect('drag_data_received', self.equip_data_received)
        equips.drag_dest_set(DEST_DEFAULT_ALL, targets_mob,GDK.ACTION_COPY)
        equips.set_selection_mode(SELECTION_BROWSE)



        swin = GtkScrolledWindow()
        swin.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC)
        swin.add_with_viewport(equips)
        self.equips = equips
        ef.add(swin)
        reset_table.attach(ef,1,2,0,1)
        gf = GtkFrame("Inventory")
        gives = GtkList()

        swin = GtkScrolledWindow()
        swin.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC)
        swin.add_with_viewport(gives)
        gf.add(swin)

        gives.connect('drag_data_received', self.give_data_received)
        gives.drag_dest_set(DEST_DEFAULT_ALL, targets_mob,GDK.ACTION_COPY)
        gives.set_selection_mode(SELECTION_BROWSE)

        self.gives = gives
        
        reset_table.attach(gf,1,2,1,2)

        self.equip_frame = ef
        self.gives_frame = gf

        noteb = GtkNotebook()
        noteb.set_tab_pos = POS_TOP
        noteb.append_page(reset_table, GtkLabel("Resets"))
        noteb.append_page(createFlags("roomflag.dat", self.roomflags, self.tooltips), GtkLabel("Flags"))
        self.ExitEd = ExitEdit([],self.ed)
        noteb.append_page(self.ExitEd, GtkLabel("Doors"))
        self.extraEd = ExtraEdit([])
        noteb.append_page(self.extraEd, GtkLabel("Extras"))
        self.koordEd = KoordEd(self)
        noteb.append_page(self.koordEd, GtkLabel("Koordinates"))
        self.attach(noteb,0,8,5,9)

    def setValues(self, room):
        room.vnum = self.vnum_entry.get_text()
        room.name = self.name.get_text()
        room.desc = self.desc.get_chars(0,self.desc.get_length())
        room.extras = self.extraEd.getExtraList()
        room.roomflags = getFlags(self.roomflags)
        self.koordEd.fillKoords(room)
        if (room.rect):
            room.calcCoords()
            
            room.rect.set(fill_color="lightgray")
            self.ed.map.canvas.update_now()


    def fillValues(self, room):
        self.room = room
        self.vnum_entry.set_text(room.vnum)
        setFlags(room.roomflags, self.roomflags)
        self.extraEd.setExtraList(room.extras)
        self.ExitEd.setExits(room.exits)
        self.koordEd.setKoords(room)
        self.name.set_text(room.name)
        self.desc.delete_text(0,-1)
        self.desc.insert_defaults(room.desc)
        self.ed.map.setRoom(room)

        if (room.rect):
            room.rect.set(fill_color="red")
            self.ed.map.canvas.update_now()
        self.update_resets()


    def empty(self):
        self.vnum_entry.set_text("")
        setFlags("", self.roomflags)
        self.extraEd.setExtraList([])
        self.ExitEd.setExits([])
        self.name.set_text("")
        self.desc.delete_text(0,-1)
#        self.ed.map.setRoom(room)
        self.update_resets()


    def create_new(self):
        if len(self.list)>0:
            room = Area.Room(self.ed.area, Area.vnum_inc(self.list[len(self.list)-1].vnum))
        else:
            room = Area.Room(self.ed.area)

        room.render(self.ed.map.canvas, self)
        return room

    def drag_rec(self, *arg):
        print "receive:",arg


##    def saveRoom(self):
##        if self.room ==None:
##            return

##        room = self.room
        
##        room.vnum = self.vnum_entry.get_text()
##        room.name = self.name.get_text()
##        room.desc = self.desc.get_chars(0,self.desc.get_length())
##        room.extras = self.extraEd.getExtraList()
##        room.roomflags = getFlags(self.roomflags)
##        if (room.rect):
##            room.rect.set(fill_color="lightgray")
##            self.ed.map.canvas.update_now()

##    def setRoom(self, room):
##        self.saveRoom()
##        self.room = room
##        self.vnum_entry.set_text(room.vnum)
##        setFlags(room.roomflags, self.roomflags)
##        self.extraEd.setExtraList(room.extras)
##        self.name.set_text(room.name)
##        self.desc.delete_text(0,-1)
##        self.desc.insert_defaults(room.desc)
##        self.ed.map.setRoom(room)
##        if (room.rect):
##            room.rect.set(fill_color="red")
##            self.ed.map.canvas.update_now()
##        self.update_resets()

    def update_resets(self):
        #print "update_resets, ed:",ed,"area:",ed.area
        self.resets.clear_items(0,-1)
        self.equips.clear_items(0,-1)
        self.gives.clear_items(0,-1)
        items = []
        if (self.room==None):
            return
        for r in self.room.resets:
            i = None
            if r.v[0]=="M":
                if not r.mob:
                    r.mob = self.ed.area.get_mob(r.v[2])
                if r.mob:
                    i = GtkListItem(r.mob.short)
                elif r.short:
                    i = GtkListItem(r.short)
                else:
                    i = GtkListItem(r.v[2])
                i.set_data("reset", r)
            elif r.v[0]=="O":
                if not r.item:
                    r.item = self.ed.area.get_item(r.v[2])
                if r.item:
                    i = GtkListItem(r.item.short)
                elif r.short:
                    i = GtkListItem(r.short)
                else:
                    i = GtkListItem(r.v[2])
                i.set_data("reset", r)
            if i:
                i.show()
                items.append(i)
                
        if len(items)>0:
            self.resets.append_items(items)



    def update_reset(self, reset):
        self.equips.clear_items(0,-1)
        self.gives.clear_items(0,-1)

        eq = []
        give = []

        for r in reset.resets:
            if r.v[0]=="G":
                r.item = self.ed.area.get_item(r.v[2])
                if r.item:
                    i = GtkListItem(r.item.short)
                elif r.short:
                    i = GtkListItem(r.short)
                else:
                    i = GtkListItem(r.v[2])
                i.set_data("reset", r)
                i.show()
                give.append(i)
            elif r.v[0]=="E":
                r.item = self.ed.area.get_item(r.v[2])
                if r.item:
                    ##print "rf:","[%s] %s" % (r.v[4], r.item.short)
                    i = GtkListItem("[%s] %s" % (Area.wearloc[r.v[4]], r.item.short))
                elif r.short:
                    i = GtkListItem("[%s] %s" % (Area.wearloc[r.v[4]], r.short))
                else:
                    i = GtkListItem(r.v[2])
                i.set_data("reset", r)
                i.show()
                eq.append(i)
            if r.v[0]=="P":
                r.item = self.ed.area.get_item(r.v[2])
                if r.item:
                    i = GtkListItem(r.item.short)
                elif r.short:
                    i = GtkListItem(r.short)
                else:
                    i = GtkListItem(r.v[2])
                i.set_data("reset", r)
                i.show()
                give.append(i)

        if (len(eq)>0):
            self.equips.append_items(eq)
##            self.equip_frame.show()
##        else:
##            self.equip_frame.hide()

        if (len(give)>0):
            self.gives.append_items(give)
##            self.gives_frame.show()
##        else:
##            self.gives_frame.hide()
        if reset.v[0]=="M":
            self.equip_frame.show()
            self.gives_frame.show()
        else:
            self.equip_frame.hide()
            self.gives_frame.show()
        
    def reset_click(self, *args):
        reset = args[1].get_data("reset")
        self.reset = reset
        self.update_reset(reset)
        


    def data_received(self, w, context, x, y, data, info, time):
        if data and data.format == 8:
            m = None
            if len(data.data)>0 :
                sio = StringIO(data.data)
                m = cPickle.load(sio)
##                msg = "Drop data of type %s was:\n\n%s" % \
##                      (data.target, m.short)
##                message_box("Drop", msg,("Continue",))
                r = Reset()
                if isinstance(m, Mobile):
                    r.v    = ["0"]*7
                    r.v[0] = "M"
                    r.v[2] = m.vnum
                    r.v[3] = "1"
                    r.v[4] = self.room.vnum
                    r.v[5] = "1"
                    r.v[6] = "* resetting %s into %s" % (m.short,self.room.name)
                    r.short = m.short
                    self.room.resets.append(r)
                    self.update_resets()
                elif isinstance(m, Item):
                    r.v    = ["0"]*6
                    r.v[0] = "O"
                    r.v[2] = m.vnum
                    r.v[3] = "1"
                    r.v[4] = self.room.vnum
                    r.v[5] = "* dropping %s into %s" % (m.short,self.room.name)
                    r.short = m.short
                    self.room.resets.append(r)
                    self.update_resets()

    def equip_data_received(self, w, context, x, y, data, info, time):
        if data and data.format == 8:
            m = None
            if len(data.data)>0 :
                sio = StringIO(data.data)
                m = cPickle.load(sio)
                
                if isinstance(m, Item):
                    r = Reset()
                    r.v    = ["0"]*6
                    r.v[0] = "E"
                    r.v[2] = m.vnum
                    r.v[3] = "1"
                    r.v[4] = "1"
                    loc = Area.get_wearloc(m, self.reset.resets)
                    if (loc <0):
                        return
                    r.v[4] = "%d" % loc
                    mob = self.ed.area.get_mob(self.reset.v[2])
                    if mob:
                        name = mob.short
                    else:
                        name = self.reset.v[2]
                    r.v[5] = "* equipping %s onto %s" % (m.short,name)
                    r.short = m.short
                    #print "reset:",r
                    self.reset.add_reset(r)
                    self.update_reset(self.reset)
                    

    def give_data_received(self, w, context, x, y, data, info, time):
        if data and data.format == 8:
            m = None
            if len(data.data)>0 :
                sio = StringIO(data.data)
                m = cPickle.load(sio)
                
                if isinstance(m, Item):
                    if self.reset.v[0]=="M":  #give item to mob
                        r = Reset()
                        r.v    = ["0"]*5
                        r.v[0] = "G"
                        r.v[2] = m.vnum
                        r.v[3] = "1"
                        mob = self.ed.area.get_mob(self.reset.v[2])
                        if mob:
                            name = mob.short
                        else:
                            name = self.reset.v[2]
                        r.v[4] = "* giving %s to %s" % (m.short,name)
                        r.short = m.short
                        ##print "reset:",r
                        self.reset.add_reset(r)
                        self.update_reset(self.reset)
                    elif self.reset.v[0]=="O": #put item into another
                        r = Reset()
                        r.v    = ["0"]*7
                        r.v[0] = "P"
                        r.v[2] = m.vnum
                        r.v[3] = "1"
                        r.v[4] = self.reset.v[2] #vnum of the item to put it in
                        r.v[5] = "1"
                        item = self.ed.area.get_item(self.reset.v[2])
                        if item:
                            name =item.short
                        else:
                            name = self.reset.v[2]
                        r.v[6] = "* putting %s into %s" % (m.short,name)
                        r.short = m.short
                        ##print "reset:",r
                        self.reset.add_reset(r)
                        self.update_reset(self.reset)
                        


