#!/usr/bin/python -OO

#  AreaEd - an editor for rom-style areas, especially for
#  Dawn of the Ages  http://dawn.netcologne.de
#
#  Copyright (C) 2001 Peter Herth <p.herth@uni-koeln.de>
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

 
try:
    from gtk import *
    from gnome.ui import *
    from GtkExtra import *
    from GDK import *
    from GTK import *
except:
    print """Unable to find the gnome-python module.\nYou must install gnome-python in order to use AreaEd.\n\nYou can download gnome-python at ftp.gnome.org or at ftp://ftp.daa.com.au/pub/james/python/."""
    raise SystemExit


import string
#import thread
import Loader

from StringIO import *
import cPickle

from Tools import *
from Area import *
import RoomForm
import ItemForm
import MobForm
import Optimizer
from time import sleep

#area = Area()
actmob = 0


            
        
            
class MobprogForm(EditForm):
    def __init__(self, ed):
        EditForm.__init__(self, ed, ed.area.mobprogs)

        self.name = mk_le("Name:",self,0,1,8)
        mklabel("Code:", self, 0,2)
        code = GtkText()
        code.set_editable(TRUE)
        code.set_usize(1,64)
        code.show()
        self.attach(code,1,8,2,4,FILL|EXPAND|SHRINK,EXPAND|FILL, XPAD, YPAD)
        self.code = code

    def fillValues(self, script):
        self.name.set_text(script.name)
        self.code.delete_text(0,-1)
        self.code.insert_defaults(script.code)

    def setValues(self, script):
        script.name = self.name.get_text()
        script.code = self.code.get_chars(0, self.code.get_length())

    def empty(self):
        self.name.set_text("")
        self.code.delete_text(0,-1)


    def create_new(self):
        if len(self.list)>0:
            return Mobprog(vnum_inc(self.list[len(self.list)-1].name),"")
        return Mobprog("1","")

class ScriptForm(EditForm):
    def __init__(self, ed):
        EditForm.__init__(self, ed, ed.area.scripts)

        self.name = mk_le("Name:",self,0,1,8)
        mklabel("Code:", self, 0,2)
        code = GtkText()
        code.set_editable(TRUE)
        code.set_usize(1,64)
        code.show()
        self.attach(code,1,8,2,4,FILL|EXPAND|SHRINK,EXPAND|FILL, XPAD, YPAD)
        self.code = code

    def fillValues(self, script):
        self.name.set_text(script.name)
        self.code.delete_text(0,-1)
        self.code.insert_defaults(script.code)

    def setValues(self, script):
        script.name = self.name.get_text()
        script.code = self.code.get_chars(0, self.code.get_length())

    def empty(self):
        self.name.set_text("")
        self.code.delete_text(0,-1)

    def create_new(self):
        if len(self.list)>0:
            return Script(vnum_inc(self.list[len(self.list)-1].name),"")
        return Script("1","")


class MapForm(GtkWindow):
    def __init__(self,ed):
        GtkWindow.__init__(self, WINDOW_TOPLEVEL, "Map")
        self.ed = ed
        table = GtkTable(2,1)
        tools = GtkFrame("Tools")
        self.z_only = None
        self.shade_other = None
        self.act_room = None
        self.pixels_per_unit = 2.0
        
        tooltable = GtkTable(4,10)
        mklabel("go", tooltable, 0, 0)
        b_north = mk_bu(" N ", tooltable, 1, 0)
        b_north.connect("clicked", self.go_dir, NORTH)
        b_east = mk_bu(" E ", tooltable, 2, 1)
        b_east.connect("clicked", self.go_dir, EAST)
        b_south=mk_bu(" S ", tooltable, 1, 2)
        b_south.connect("clicked", self.go_dir, SOUTH)
        b_west = mk_bu(" W ", tooltable, 0, 1)
        b_west.connect("clicked", self.go_dir, WEST)
        b_up   = mk_bu(" U ", tooltable, 2, 0)
        b_up.connect("clicked", self.go_dir, UP)
        b_down = mk_bu(" D ", tooltable, 0, 2)
        b_down.connect("clicked", self.go_dir, DOWN)

        self.go_buttons = [ b_north, b_east, b_south, b_west, b_up, b_down]
        
        mklabel("",tooltable,0,3)
        mklabel("digg", tooltable, 0, 4)
        d_north = mk_bu(" N ", tooltable, 1, 4)
        d_north.connect("clicked", self.dig_dir, NORTH)
        d_east  = mk_bu(" E ", tooltable, 2, 5)
        d_east.connect("clicked", self.dig_dir, EAST)
        d_south = mk_bu(" S ", tooltable, 1, 6)
        d_south.connect("clicked", self.dig_dir, SOUTH)
        d_west  = mk_bu(" W ", tooltable, 0, 5)
        d_west.connect("clicked", self.dig_dir, WEST)
        d_up    = mk_bu(" U ", tooltable, 2, 4)
        d_up.connect("clicked", self.dig_dir, UP)
        d_down  = mk_bu(" D ", tooltable, 0, 6)
        d_down.connect("clicked", self.dig_dir, DOWN)



        self.dig_buttons = [ d_north, d_east, d_south, d_west, d_up, d_down]

        mk_bu("New Room",    tooltable, 0, 7, 4, FILL)
        mk_bu("Delete Room", tooltable, 0, 8, 4, FILL)


        mklabel("zoom", tooltable, 0, 9)
        zoom_in = mk_bu(" + ", tooltable ,1,9)
        zoom_out = mk_bu(" - ", tooltable ,2,9)
        zoom_reset = mk_bu("1:1", tooltable, 3,9)


        
        zoom_in.connect("clicked", self.zoom_in)
        zoom_out.connect("clicked", self.zoom_out)
        zoom_reset.connect("clicked", self.zoom_reset)
        
        optimize = mk_bu("Show Optimizer", tooltable, 0, 10, 4,FILL)
        optimize.connect("clicked", self.optimize)

##        zonly = mk_bu("hide z", tooltable, 0, 11,2)
##        zall = mk_bu("show z", tooltable, 2, 11,4)
##        zonly.connect("clicked", self.z_only)
##        zall.connect("clicked", self.z_all)



        z_setting = GtkCheckButton("z-sensitive")
        tooltable.attach(z_setting,0,4,11,12,FILL, 0)
        z_setting.connect("toggled", self.z_toggled)
        self.z_setting = z_setting
        z_shade =GtkCheckButton("shade other")
        tooltable.attach(z_shade, 0,4, 12,13, FILL,0)
        z_shade.connect("toggled", self.zshade_toggled)
        self.z_shade = z_shade
        
        tools.add(tooltable)
        map_frame = GtkFrame("Map");

        #push_rgb_visual()
        canvas = GnomeCanvas()
        #pop_visual()
        
        self.canvas = canvas
        canvas.show()

        canvas.set_pixels_per_unit(self.pixels_per_unit)
        canvas.set_scroll_region(-500,-500, 1000, 1000)

        ctable = GtkTable(2,2)
        canvas.set_usize(100,100)
        root = canvas.root()
        root.add("rect",x1=-400,y1=-400, x2=600, y2=600, fill_color="white")
                            
        ctable.attach(canvas,0,1,0,1)
        hscroll = GtkHScrollbar(canvas.get_hadjustment())
        ctable.attach(hscroll,0,1,1,2,EXPAND|SHRINK|FILL,0)
        vscroll = GtkVScrollbar(canvas.get_vadjustment())
        ctable.attach(vscroll,1,2,0,1,0,EXPAND|SHRINK|FILL)

        map_frame.add(ctable)
        table.attach(tools,1,2,0,1,0,0)
        table.attach(map_frame,0,1,0,1)
        self.add(table)
        self.connect("delete_event", self.eclose)
        canvas.update_now()


    def hide_z(self):
        for r in self.ed.area.rooms:
            if r.rect:
                if r.z != self.act_room.z:
                    if self.shade_other:
                        r.rect.set(fill_color=None,outline_color="lightgray")
                        r.rect.show()
                    else:
                        r.rect.hide()
                    for e in r.exits:
                        if e and e.line:
                            if self.shade_other:
                                e.line.set(fill_color="lightgray")
                                e.line.show()
                            else:
                                e.line.hide()
                else:
                    r.rect.show()
                    if r == self.act_room:
                        r.rect.set(fill_color="red",outline_color="black")
                    else:
                        r.rect.set(fill_color="lightgray",outline_color="black")
                    for e in r.exits:
                        if e and e.line:
                            e.line.set(fill_color="black")
                            e.line.show()

    def show_all_rooms(self):
        for r in self.ed.area.rooms:
            if r.rect:
                r.rect.show()
                for e in r.exits:
                    if e and e.line:
                        e.line.show()
        
    def z_toggled(self, *args):
        self.z_only = self.z_setting.get_active()
        if self.act_room == None:
            return
        if self.z_only:
            self.hide_z()
        else:
            self.unshade_all()
            self.show_all_rooms()

    def unshade_all(self):
        for r in self.ed.area.rooms:
            if r.rect:
                if r == self.act_room:
                    r.rect.set(fill_color="red",outline_color="black")
                else:
                    r.rect.set(fill_color="lightgray",outline_color="black")
                for e in r.exits:
                    if e and e.line:
                        e.line.set(fill_color="black")
                            
    def zshade_toggled(self, *args):
        self.shade_other = self.z_shade.get_active()
        if not self.shade_other:
            self.unshade_all()
            
            
        if self.z_only:
            self.hide_z()
        else:
            self.show_all_rooms()


            
    def create_toolbar(self):
        toolbar = [
            UIINFO_ITEM_STOCK("New", "Create a new area", None,STOCK_PIXMAP_NEW),
            UIINFO_SEPARATOR]
        return toolbar
        
    def eclose(self, *arg):
        self.hide_all()
        return TRUE


    def zoom_in(self, *args):
        self.pixels_per_unit = self.pixels_per_unit * 1.2
        self.canvas.set_pixels_per_unit(self.pixels_per_unit)
        
    def zoom_out(self, *args):
        self.pixels_per_unit = self.pixels_per_unit / 1.2
        self.canvas.set_pixels_per_unit(self.pixels_per_unit)

    def zoom_reset(self, *args):
        self.pixels_per_unit = 2
        self.canvas.set_pixels_per_unit(self.pixels_per_unit)
        

    def setRoom(self, room):
        #print "setroom:",room.vnum,"exits:",room.exits
        old_room = self.act_room
        self.act_room = room
        
        if old_room and self.z_only and self.act_room.z != old_room.z:
            self.hide_z()

        for dir in range(6):
            if room.exits[dir] != None:
                self.go_buttons[dir].set_sensitive(1)
                self.dig_buttons[dir].set_sensitive(0)
            else:
                self.dig_buttons[dir].set_sensitive(1)
                self.go_buttons[dir].set_sensitive(0)

        

    def go_dir(self, *args):
        dir = args[1]
        r = self.ed.roomform.actitem
        if r != None:
            e = r.exits[dir]
            if e:
                if self.ed.area.r_v.has_key(e.roomToVnum):
                    to = self.ed.area.r_v[e.roomToVnum]
                    self.ed.roomform.set(to)

    def dig_dir(self, *args):
        """ dir from current room in the given direction """
        dir = args[1]
        r = self.ed.roomform.actitem    # get the current room
        if r==None:                     # wrong alarm
            return

        x = r.x                         # calculate destination coordinats
        y = r.y
        z = r.z

        if dir == NORTH:
            y = r.y - 20
        elif dir == EAST:
            x = r.x + 20
        elif dir == SOUTH:
            y = r.y + 20
        elif dir == WEST:
            x = r.x - 20
        elif dir == UP:
            z = r.z + 20
        elif dir == DOWN:
            z = r.z - 20

        room = self.ed.area.find_room(x,y,z) # do we have a room there ?
        
        
        if room != None:                # if yes, only connect
            e1 = Exit()
            e1.dir = dir
            e1.roomToVnum = room.vnum
            r.exits[dir] = e1

            odir = op_dir(dir)
            if room.exits[odir] == None: # back-connect if not already there
                e2 = Exit()
                e2.dir = odir
                e2.roomToVnum = r.vnum
                room.exits[odir] = e2
                e2.render(room, self.canvas,self.ed.area)


            self.ed.roomform.actroom= self.ed.area.find_roomnr(room)

            e1.render(r, self.canvas, self.ed.area,1)
            
            self.ed.roomform.set(room)

        else:                            # create new room and connect
            room = Room(self.ed.area)
            vnum = "1"
            if (len(self.ed.area.rooms) > 0):
                vnum = vnum_inc(self.ed.area.rooms[len(self.ed.area.rooms)-1].vnum)
            room.vnum = vnum
            room.hasCoords = 1
            self.ed.area.r_v[vnum] = room

            e1 = Exit()
            e1.dir = dir
            e1.roomToVnum = vnum
            r.exits[dir] = e1
            
            e2 = Exit()
            odir = op_dir(dir)
            e2.dir = odir
            e2.roomToVnum = r.vnum
            room.exits[odir] = e2

            room.x = x
            room.y = y
            room.z = z
            room.hasCoords = 1
        
            room.calcCoords()

            self.ed.roomform.actroom=len(self.ed.area.rooms)
            self.ed.area.rooms.append(room)

            e1.render(r, self.canvas, self.ed.area)
            e2.render(room, self.canvas,self.ed.area)
            room.render(self.canvas, self.ed.roomform)
            self.ed.roomform.set(room)
            self.setRoom(room)
            
    def drawMap(self, area):
        root = self.canvas.root()
        rooms = area.rooms[:]
        rooms.sort(room_cmp_by_z)
        for r in rooms:
            if (r.z!=-999990):
                r.render(self.canvas, self.ed.roomform)
                for e in r.exits:               
                    if e and area.r_v.has_key(e.roomToVnum):
                        to = area.r_v[e.roomToVnum]
                        e.render(r,self.canvas, area)
                            
    def optimize(self, *args):
        reload(Optimizer)
        self.optimizer = Optimizer.Optimizer(self, self.ed)
        self.optimizer.show_all()



        

##################################################################

    

from string import joinfields, splitfields, ljust
import GtkExtra

#from math import sqrt
#GOLDEN = 2./(1. + sqrt(5.))


class AreaForm(GtkTable):
    def __init__(self):
        GtkTable.__init__(self, 2,4)
        self.filename = mk_le("filename:",self, 0, 0)
        self.areaname = mk_le("areaname:",self, 0, 1)
        self.command = mk_le("command:", self, 0, 2)
        self.vnums = mk_le("vnum:", self, 0, 3)

class HelpForm(GtkTable):
    def __init__(self):
        GtkTable.__init__(self, 2,4)
        self.topic = mk_le("topic:", self, 0, 0)
        self.level = mk_le("level:", self, 2, 0)
        mklabel("text:", self, 0,1)
        text = GtkText()
        text.set_editable(TRUE)
        text.set_usize(1,2)
        text.show()
        self.attach(text,1,4,1,3,FILL|EXPAND|SHRINK,EXPAND|FILL, XPAD, YPAD)
        self.text = text


class Progress(GtkWindow):
    def __init__(self,  app, filename):
        GtkWindow.__init__(self, WINDOW_TOPLEVEL,"Loading "+filename)
        
        table = GtkTable(1,2)
        self.pbar = GtkProgressBar()
        table.attach(GtkLabel("Loading..."), 0,1, 0,1)
        table.attach(self.pbar, 0,1,1,2,EXPAND|FILL,0)
        self.add(table)
        self.pbar.set_activity_mode(PROGRESS_CONTINUOUS)
        self.pbar.set_bar_style(PROGRESS_CONTINUOUS)
        self.set_usize(400, 200)
        self.set_position(WIN_POS_CENTER)
        self.show_all()
        self.update()

    def set_percent(self, pct):
        self.pbar.set_percentage(pct)
        self.pbar.update(pct)
        self.update()
        
    def update(self):
        while(events_pending()):
            mainiteration()

   
class AreaEd(GnomeApp):
    """Main class of the Area Editor
    """
    version = "2.0 beta 7"


    def __init__(self, title, width=800, height=600):
        GnomeApp.__init__(self,"areaed", "AreaEd")
        self.connect("destroy", mainquit)
        self.appbar = GnomeAppBar(1,1)
        self.appbar.set_status("Ok.")
        self.appbar.show()
        self.set_statusbar(self.appbar)        

	title = "AreaEd V %s" % self.version
        self.set_title(title)
        self.connect("destroy", mainquit)
        self.set_usize(width, height)
        self.set_position(WIN_POS_CENTER)
        self.lists = None
        
	self.width = width
	self.height = height
        
        self.area = Area()
        self.filename = None
        
        self.roomform = RoomForm.RoomForm(self)
        self.map = MapForm(self)
        self.mobform = MobForm.MobForm(self)
        self.itemform = ItemForm.ItemForm(self)
        self.scriptform = ScriptForm(self)
        self.mobprogform = MobprogForm(self)
        
        self.lists = ListForm(self)
        
	self.create_widgets()
        
    def create_widgets(self):
	self.vbox = GtkVBox()
        self.set_contents(self.vbox)
        ##self.hpane = GtkHPaned()

        ##self.hpane.set_gutter_size(12)
        ##self.hpane.set_handle_size(100)

        menu = self.create_menu()
	menus=self.create_menus( menu )
	self.create_toolbar( self.createtoolbar() )

        ##self.create_tree()
        self.create_notebook()

        


        
##        self.vbox.pack_start(self.hpane)

        self.show_all()

    def create_tree(self):
##        tree = GtkTree()
##        tree_root_node = GtkTreeItem("Area")
##        tree.append(tree_root_node)
##        subtree = GtkTree()

##        tree_rooms = GtkTreeItem("Rooms (0)")
##        tree_rooms.show()
##        subtree.append(tree_rooms)

##        st = GtkTree()
##        tree_rooms.set_subtree(st)

##        for i in range(20):
##            r = GtkTreeItem("#00%d"%i)
##            r.show()
##            st.append(r)
            
##        self.tree_rooms_tree = st        

##        tree_mobiles = GtkTreeItem("Mobiles (0)")
##        tree_mobiles.show()
##        subtree.append(tree_mobiles)

##        tree_items = GtkTreeItem("Items (0)")
##        tree_items.show()
##        subtree.append(tree_items)
        

##        tree_root_node.set_subtree(subtree)

        tree = GtkCTree(1)

        self.tree_root_node = tree.insert_node(None,None,["Area"],is_leaf = FALSE)
        self.tree_mobiles = tree.insert_node(self.tree_root_node, None, ["Mobiles"],is_leaf = FALSE)
        self.tree_items = tree.insert_node(self.tree_root_node, None, ["Items"],is_leaf = FALSE)
        self.tree_rooms = tree.insert_node(self.tree_root_node, None, ["Rooms"],is_leaf = FALSE)
##        for i in range(20):
##            tree.insert_node(self.tree_rooms, None, ["#00%d"%i])


        swin = GtkScrolledWindow()
        swin.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC)
        swin.add_with_viewport(tree)
        self.hpane.add1(swin)

        self.tree = tree
        tree.connect("select_row", self.tree_event)
        #tree.connect("drag_begin", self.drag_start)
        tree.show()
        tree.connect("drag_begin", self.drag_start)
        #tree.drag_source_set(BUTTON1_MASK, [("move",0,-1)], ACTION_COPY)
        tree.connect('drag_data_get', dnd_drag_data_get)

        tree.drag_source_set(GDK.BUTTON1_MASK|GDK.BUTTON3_MASK, dnd_targets, GDK.ACTION_COPY)

    def drag_start(self, *args):
        #print "drag:", args
        pass
        
    def tree_event(self, *args):
        print "Tree:",args
        pass
        
    def create_notebook(self):
        notebook = GtkNotebook()
        notebook.set_tab_pos = POS_TOP

        area = AreaForm()
        notebook.append_page(area, GtkLabel("Area"))

        self.helps = HelpForm()
        notebook.append_page(self.helps, GtkLabel("Helps"))

        swin = GtkScrolledWindow()
        swin.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC)


        swin.add_with_viewport(self.mobform)
        self.mobform_page = swin
        notebook.append_page(swin, GtkLabel("Mobiles"))

        swin = GtkScrolledWindow()
        swin.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC)
        swin.add_with_viewport(self.itemform)
        self.itemform_page = swin
        notebook.append_page(swin, GtkLabel("Items"))

        swin = GtkScrolledWindow()
        swin.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC)
        swin.add_with_viewport(self.roomform)
        self.roomform_page = swin
        notebook.append_page(swin, GtkLabel("Rooms"))
        
        notebook.append_page(self.scriptform, GtkLabel("Scripts"))
        notebook.append_page(self.mobprogform, GtkLabel("Progs"))
        
        notebook.append_page(GtkFrame("to be done"), GtkLabel("Shops"))

        self.notebook = notebook
        ##self.hpane.add2(notebook)
        self.vbox.pack_start(notebook)

         
    def create_menubar(self):
	ag = GtkAccelGroup()
	itemf = GtkItemFactory(GtkMenuBar, "<main>", ag)
	self.add_accel_group(ag)
	itemf.create_items([
	    ('/_File',            None,        None,     0, '<Branch>'),
            ('/File/tearoff1',    None,        None,     0, '<Tearoff>'), 
	    ('/_File/_New',       None,        None,     1, ''),
	    ('/_File/_Load',      None, self.load_file,  1, ''),
	    ('/_File/sep1',       None,        None,     0, '<Separator>'),
	    ('/_File/_Save',      None,        None,     0, '<Item>'),
	    ('/_File/sep2',       None,        None,     0, '<Separator>'),
	    ('/_File/E_xit',      '<alt>X',    mainquit, 0, ''),
##            ('/_Mobile',          None,        None,     0, '<Branch>'),
##	    ('/Mobile/_New',      None,        None,     1, ''),
##	    ('/Mobile/_Delete',   None,        None,     1, ''),
            ('/_Item',            None,        None,     0, '<Branch>'),            
##	    ('/Item/_New',        None,        None,     1, ''),
##	    ('/Item/_Delete',     None,        None,     1, ''),
            ('/_Room',            None,        None,     0, '<Branch>'),
	    ('/Room/_New',        None,        None,     1, ''),
	    ('/Room/_Delete',     None,        None,     1, ''),
	    ('/_Help',            None,        None,     0,   '<LastBranch>'),
	    ('/_Help/_About...',  None, self.help_about, 1, '')
	    ])	
	self.menu_bar = itemf.get_widget('<main>')
	self.dbmenu = itemf.get_widget('/File')
	self.dbmenu_pos = 3

        hdlbox = GtkHandleBox()
        self.vbox.pack_start(hdlbox, expand=FALSE)
        hdlbox.add(self.menu_bar)

    def showlist(self, *args):
        self.lists.show_all()

    def nm(self,*arg):
        ##newMob()
        self.mobform.new()
        self.notebook.set_page(2)
        
    def newItem(self, *arg):
        item = Item()
        vnum = "1"
        if (len(self.area.items) > 0):
            vnum = vnum_inc(self.area.items[len(self.area.items)-1].vnum)
        item.vnum = vnum
        self.itemform.actitem=len(self.area.items)
        self.area.items.append(item)
        self.itemform.setItem(item)

    def ni(self,*arg):
        self.newItem()
        self.notebook.set_page(3)

    def newRoom(self, *arg):
        room = Room()
        vnum = "1"
        if (len(self.area.rooms) > 0):
            vnum = vnum_inc(self.area.rooms[len(self.area.rooms)-1].vnum)
        room.vnum = vnum
        self.area.r_v[vnum] = room
        room.hasCoords = 1
        self.roomform.actroom=len(self.area.rooms)
        self.area.rooms.append(room)

        room.render(self.map.canvas, self.roomform)
        self.roomform.set(room)    

    def nr(self,*arg):
        self.newRoom()
        self.notebook.set_page(4)

    def do_delete_mob(self, *arg):
        pass #print "arg:",arg

    def do_delete_item(self, *arg):
        pass #print "arg:",arg

    def do_delete_room(self, *arg):
        pass #print "arg:",arg

    
    def delete_mob(self, *arg):
        dialog = GnomeQuestionDialog("Do you really want to delete the mob?",self.do_delete_mob, self)
        dialog.run()

    def delete_item(self, *arg):
        dialog = GnomeQuestionDialog("Do you really want to delete the item?",self.do_delete_item, self)
        dialog.run()

    def delete_room(self, *arg):
        dialog = GnomeQuestionDialog("Do you really want to delete the room?",self.do_delete_room, self)
        dialog.run()

    def show_map(self, *arg):
        self.map.show_all()
        
    def create_menu(self):
        file_menu = [
            UIINFO_MENU_NEW_ITEM("_New",None,self.area_new), #'New', None,  None, STOCK_MENU_NEW),
            UIINFO_SEPARATOR,
            UIINFO_MENU_OPEN_ITEM(self.load_file),
            UIINFO_SEPARATOR,
            UIINFO_MENU_SAVE_ITEM(self.save_file),
            UIINFO_MENU_SAVE_AS_ITEM(self.save_file_as),

            UIINFO_SEPARATOR,
            UIINFO_MENU_EXIT_ITEM(mainquit)
            ]
        edit_menu = [
            UIINFO_ITEM_STOCK("_Lists", "Show lists window", self.showlist, STOCK_MENU_NEW),
            UIINFO_SEPARATOR,
            UIINFO_MENU_PASTE_ITEM(None),
            UIINFO_MENU_CUT_ITEM(None),
            UIINFO_MENU_COPY_ITEM(None),
            ]
##        mobs_menu = [
###            (APP_UI_ITEM, "New", "Create a new mobile", self.nm, None,APP_PIXMAP_FILENAME, None, GDK.a, 0),
##            UIINFO_ITEM_STOCK("_New",  "Create a new mobile", self.nm, STOCK_MENU_NEW),
##            UIINFO_ITEM_STOCK("_Delete", None,  self.delete_mob, STOCK_MENU_CUT),
##            ]
        items_menu = [
##            UIINFO_MENU_NEW_ITEM("_New",None, self.ni, STOCK_MENU_NEW),
##            UIINFO_ITEM_STOCK('_Delete', None,  self.delete_item, STOCK_MENU_CUT),
##            UIINFO_SEPARATOR,
            UIINFO_ITEM_STOCK("AC - normal", None, self.itemform.calcAcNorm, STOCK_MENU_NEW),
            UIINFO_ITEM_STOCK("AC - legendary", None, self.itemform.calcAcLeg, STOCK_MENU_NEW),
            UIINFO_ITEM_STOCK("AC - limited1", None, self.itemform.calcAcLim1, STOCK_MENU_NEW),
            UIINFO_ITEM_STOCK("AC - limited2", None, self.itemform.calcAcLim2, STOCK_MENU_NEW),
            ]
##        rooms_menu = [
##            UIINFO_MENU_NEW_ITEM("_New",None, self.nr, STOCK_MENU_NEW),
##            UIINFO_ITEM_STOCK('_Delete', None,  self.delete_room, STOCK_MENU_CUT),
##            ]
        reload_menu = [
            UIINFO_ITEM_STOCK("_Mob form", None, self.reload_mobform, STOCK_MENU_NEW),
            UIINFO_ITEM_STOCK("_Item form", None, self.reload_itemform, STOCK_MENU_NEW),
            UIINFO_ITEM_STOCK("_Room form", None, self.reload_roomform, STOCK_MENU_NEW)
            ]
        help_menu = [
            UIINFO_MENU_ABOUT_ITEM( self.help_about)
            ]
        menu_info = [
            UIINFO_SUBTREE('_File', file_menu),
            UIINFO_SUBTREE('_Edit', edit_menu),
##            UIINFO_SUBTREE('_Mobs', mobs_menu),
            UIINFO_SUBTREE('_Items', items_menu),
##            UIINFO_SUBTREE('_Rooms', rooms_menu),
            UIINFO_SUBTREE('Re_load', reload_menu),
            UIINFO_SUBTREE('_Help', help_menu)
            ]
        return menu_info

    def createtoolbar(self):
        toolbar_info = [
            UIINFO_ITEM_STOCK("New", "Create a new area", self.area_new, STOCK_PIXMAP_NEW),
            UIINFO_SEPARATOR,
            UIINFO_ITEM_STOCK("Open", "Load an existing ara", self.load_file,STOCK_PIXMAP_OPEN),
            UIINFO_ITEM_STOCK("Save", "Save current area", self.save_file,STOCK_PIXMAP_SAVE),
            UIINFO_ITEM_STOCK("Save As", "Save current area as a new file", self.save_file_as,STOCK_PIXMAP_SAVE_AS),
            UIINFO_SEPARATOR,
            UIINFO_ITEM_STOCK("Map", "Edit the map of the area", self.show_map,STOCK_PIXMAP_BOOK_OPEN),
            UIINFO_SEPARATOR,
            UIINFO_ITEM_STOCK("Quit", "Quit AreaEd", mainquit,STOCK_PIXMAP_QUIT),

##            UIINFO_ITEM_STOCK('New', None, None,
##                              STOCK_PIXMAP_MAIL_NEW),
##            UIINFO_ITEM_STOCK('Reply', None, self.reply_callback,
##                              STOCK_PIXMAP_MAIL_RPL),
##            UIINFO_ITEM_STOCK('Forward', None, self.forward_callback,
##                              STOCK_PIXMAP_MAIL_FWD),
##            UIINFO_SEPARATOR,
##            UIINFO_ITEM_STOCK('Previous', None, self.prev_msg_callback,
##                              STOCK_PIXMAP_BACK),
##            UIINFO_ITEM_STOCK('Next', None, self.next_msg_callback,
##                              STOCK_PIXMAP_FORWARD),
##            UIINFO_SEPARATOR,
##            UIINFO_ITEM_STOCK('Delete', None, self.trash_msg,
##                              STOCK_PIXMAP_TRASH),
            ]
        return toolbar_info


    def area_new(self, *args):
        dialog = GnomeQuestionDialog("Do you really want to create a new area?\n(This will erase any data)",self.do_area_new, self)
        dialog.run()

    def do_area_new(self, *args):
        if (args[0]==1):
            return
        
        self.area = Area()
        self.filename = None
        self.map.hide()
        self.map = MapForm(self)
        self.mobform.setList(self.area.mobs)
        self.roomform.setList(self.area.rooms)
        self.itemform.setList(self.area.items)
        self.mobprogform.setList(self.area.mobprogs)
        self.scriptform.setList(self.area.scripts)

        if (self.lists):
            self.lists.set_area(self.area)
        if len(self.area.items)>0:
            self.itemform.set(self.area.items[0])
        if len(self.area.rooms)>0:
            self.roomform.set(self.area.rooms[0])

        self.area.automap()
        self.map.drawMap(self.area)
        


    def save(self, filename):
        self.mobform.save()
        self.itemform.save()
        self.roomform.save()
        self.area.save(filename)
        print "saved %s" % filename

    def save_file(self, *args):
        if not self.filename:
            self.filename = file_save_box()
        if self.filename:
            self.save(self.filename)

            
            
##            dialog = GnomeErrorDialog("No area open  ", self)
##            dialog.run()
            


    def save_file_as(self, *args):
        filename = file_save_box()
        if filename:
            self.filename = filename
            self.save(filename)
            
    def load_file(self, *args):
        ##global area
        ##sel = GtkFileSelection("Load Area")
        ##        sel.show()
        ##filename = sel.get_filename()
        filename = file_open_box()
        #progress = Progress(self,filename)
        #thread.start_new_thread(self.lf, (filename,progress))
        if filename == None:
            return
        self.filename = filename
        self.area = Loader.load(filename)
        
        ##if len(area.mobs)>0:
        self.mobform.setList(self.area.mobs)
        self.roomform.setList(self.area.rooms)
        self.itemform.setList(self.area.items)
        self.mobprogform.setList(self.area.mobprogs)
        self.scriptform.setList(self.area.scripts)

        if (self.lists):
            self.lists.set_area(self.area)
        if len(self.area.items)>0:
            self.itemform.set(self.area.items[0])
        if len(self.area.rooms)>0:
            self.roomform.set(self.area.rooms[0])

        self.area.automap()
        self.map.drawMap(self.area)

        ##self.tree.node_set_text(self.tree_mobiles,0,"Mobiles (%d)" % len(area.mobs))
##        for m in area.mobs:                         
##            node = self.tree.insert_node(self.tree_mobiles, None, [m.vnum])
##            #m.node = node
##        self.tree.node_set_text(self.tree_items,0,"Items (%d)" % len(area.items))
##        for i in area.items:                         
##            node = self.tree.insert_node(self.tree_items, None, [i.vnum])
##            i.node = node
##        self.tree.node_set_text(self.tree_rooms,0,"Rooms (%d)" % len(area.rooms))
##        for r in area.rooms:                         
##            node = self.tree.insert_node(self.tree_rooms, None, [r.vnum])
##            r.node = node
        #progress.hide()

    def setmob(self, mobile):
        self.mobform.set(mobile)
    def setitem(self, item):
        self.itemform.set(item)
    def setroom(self, room):
        self.roomform.set(room)

    def refresh_lists(self):
        self.lists.set_area(self.area)
        
    def help_about(self, *args):
        about = GnomeAbout(" AreaEd",
                           self.version,
                           "Copyright \251 2001 P. Herth",
                           ["Peter Herth <herth@netcologne.de>"],
                           "THE Area Editor for Linux\nHave fun!",
                           "Have fun!", None)
        about.set_parent(self)
        about.run()



    def reload_mobform(self, *args):
        reload(MobForm)
        self.mobform = MobForm.MobForm(self)
        swin = GtkScrolledWindow()
        swin.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC)
        #swin.add_with_viewport(self.mobform.frame)
        swin.add_with_viewport(self.mobform)

        nr = self.notebook.page_num(self.mobform_page)
        self.notebook.remove_page(nr)
        self.notebook.insert_page(swin, GtkLabel("Mobs"),nr)
        self.mobform_page = swin
        swin.show_all()
        self.notebook.set_page(nr)
        
    def reload_itemform(self, *args):
        reload(ItemForm)
        self.itemform = ItemForm.ItemForm(self)
        swin = GtkScrolledWindow()
        swin.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC)
        swin.add_with_viewport(self.itemform)

        nr = self.notebook.page_num(self.itemform_page)
        self.notebook.remove_page(nr)
        self.notebook.insert_page(swin, GtkLabel("Items"),nr)
        self.itemform_page = swin
        swin.show_all()
        self.notebook.set_page(nr)
        
    def reload_roomform(self, *args):
        reload(RoomForm)
        self.roomform = RoomForm.RoomForm(self)
        swin = GtkScrolledWindow()
        swin.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC)
        swin.add_with_viewport(self.roomform)

        nr = self.notebook.page_num(self.roomform_page)
        self.notebook.remove_page(nr)
        self.notebook.insert_page(swin, GtkLabel("Rooms"),nr)
        self.roomform_page = swin
        swin.show_all()
        self.notebook.set_page(nr)
        
swidth = screen_width()

if (swidth <= 800):
    width=640
    height=400
elif (swidth <= 1024):
    width=800
    height=500
elif (swidth <= 1280):
    width=800
    height=700
else:
    width=800
    height=730
    

##p = Progress(1,"file")
##p.set_percent(0.33)
##p.set_percent(0.66)


ed = AreaEd("", width, height)
##p.set_percent(0.99)
##p.hide()
##import signal
##import sys
##def sig_int(signal, frame):
##    print "sigint"
##    raise SystemExit

#signal.signal(signal.SIGINT, sig_int)
mainloop()      

